import * as React from "react";
import { Windup } from "../Windup";
import { HookMetadata } from "./useWindup";
declare type MsProp = {
    ms: number;
};
declare type GetPaceProp = {
    getPace: (char: string) => number;
};
declare type PaceProps = MsProp | GetPaceProp;
export declare function defaultGetPace(lastChar: string, nextChar: string | undefined): number;
declare const Pace: React.FC<React.PropsWithChildren<PaceProps>>;
export declare function isPaceElement(element: React.ReactElement): element is React.ReactElement<PaceProps>;
export declare function isMsProp(props: PaceProps): props is MsProp;
export declare function paceFromWindup<M extends HookMetadata, W extends Windup<string, M>>(windup: W, parentPace?: (char: string, nextChar: string | undefined) => number): ((char: string, nextChar: string | undefined) => number) | undefined;
export default Pace;
